import argparse

# def config_rep(device, cell, level, reduce_dim=None):
#     assert cell in ['hepg2']
#     args = argparse.Namespace()
#     args.name = cell
#     args.device = device 
#     args.level = level 
#     # args.embed_dim = 1280
#     # args.num_layers = 33
#     # args.hidden_dim = 256
#     args.length = 200
#     # if cell == 'GFP':
#     #     args.length = 237
#     #     args.num_tokens = 237 + 2
#     #     args.reduce_dim = 32
#     #     args.num_trainable_layers = 4
#     # elif cell == 'AAV':
#     #     args.length = 28
#     #     args.num_tokens = 28 + 2
#     #     args.reduce_dim = 16
#     #     args.num_trainable_layers = 4
#     # else:
#     #     raise NotImplementedError()
#     # if reduce_dim != None:
#     #     args.reduce_dim = reduce_dim
#     return args

def create_base(args):
    assert args.cell in [
        'complex', 
        'defined',
        "hepg2",
        "k562",
        "sknsh",
    ]
    opt = argparse.Namespace()
    opt.name = args.cell
    opt.device = args.device 
    opt.level = args.level
    opt.length, opt.min_fitness, opt.max_fitness = get_fitness_info(args.cell)
    # opt.seq_pretrained =f'saved/{args.protein}_{args.level}_LM.pt'
    opt.rew_pretrained = get_oracle_path(args.cell)
    return opt

def get_oracle_path(cell):
    if cell == "complex":
        path = ""
    elif cell == "defined":
        path = ""
    elif cell == "hepg2":
        path = ""
    elif cell == "k562":
        path = ""
    elif cell == "sknsh":
        path = ""
    else:
        raise NotImplementedError()
    return path    
        
def get_fitness_info(cell):
    if cell == 'complex':
        length = 80
        min_fitness = 0
        max_fitness = 17
    elif cell == 'defined':
        length = 80
        min_fitness = 9
        max_fitness = 17
    elif cell == 'hepg2':
        length = 200
        min_fitness = -6.051336
        max_fitness = 10.992575
    elif cell == 'k562':
        length = 200
        min_fitness = -5.857445
        max_fitness = 10.781755
    elif cell == 'sknsh':
        length = 200
        min_fitness = -7.283977
        max_fitness = 12.888308
    else:
        raise NotImplementedError()
    return length, min_fitness, max_fitness

# def create_base(args):
#     assert args.cell in ['GFP', 'AAV']
#     opt = argparse.Namespace()
#     opt.name = args.cell
#     opt.device = args.device 
#     opt.level = args.level
#     opt.length, opt.min_fitness, opt.max_fitness = get_fitness_info(args.cell)
#     opt.seq_pretrained =f'saved/{args.cell}_{args.level}_LM.pt'
#     opt.rew_pretrained = f'ckpt/{opt.name}/oracle.ckpt' 
#     opt.reduce_dim = None
#     return opt

def create_opt(args):
    assert args.cell in ['hepg2']
    opt = argparse.Namespace()
    opt.name = args.cell
    opt.device = args.device 
    opt.level = args.level
    opt.not_sparse = args.not_sparse
    opt.length, opt.min_fitness, opt.max_fitness = get_fitness_info(args.cell)
    opt.step_mut = args.step_mut
    if args.cell == 'hepg2':
        opt.done_cond = argparse.Namespace(max_steps=10, max_mutation=20000, step_mut=opt.step_mut)

    # opt.oracle_path = "/home/v-zhaoyang2/project/DNARL/artifacts/DNA-model:v0/reward_model.ckpt"
    opt.rew_pretrained = get_oracle_path(args.cell)
    return opt

# def create_rep_from_opt(opt):
#     return config_rep(opt.device, opt.name, opt.level, opt.reduce_dim)
